package dvdrZ.uTwente.Skilift;

import java.util.List;
import java.util.Stack;

public class Storage
{
    private Car[] cars;
    private int index = 0;

    private final int capacity;

    /*@
      requires Perm(capacity,50);
      ensures Perm(capacity,50);
     @*/
    public int getCapacity()
    {
        return capacity;
    }

    private final CarType type;

    //@ensures Perm(capacity,100) ** Perm(index,100) ** Perm(type,100) ** Perm(cars,100);
    public Storage(CarType type, int capacity)
    {
        this.capacity = capacity;
        this.type = type;
        cars = new Car[capacity];
    }


    /*@
      requires Perm(cars,50);
      ensures Perm(cars,50);
     @*/
    public int Count()
    {

        return index;
    }

    /*@
      requires Perm(type,50);
      ensures Perm(type,50);
     @*/
    public CarType getType()
    {
        return type;
    }

    /*@
      requires Perm(cars[index],100) ** Perm(index,100);
      ensures Perm(cars[index],100) ** Perm(index,100);
     @*/
    public void addCar(Car car)
    {
        if (index < capacity)
        {
            if (car.getType() == type)
            {
                cars[index] = car;
                index++;
            }
            else
            {
                throw new CarMisplacedException(type, car.getType());
            }
        }
        else
        {
            throw new StorageFullException();
        }
    }

    /*@
      requires Perm(cars[index-1],100) ** Perm(index,100);
      ensures Perm(cars[index-1],100) ** Perm(index,100);
     @*/
    public Car getCar()
    {
        Car retval = null;
        if (index > 0)
        {
            retval = cars[--index];

        }
        return retval;
    }


}
